#!/usr/bin/perl

if ($#ARGV != 1) {
  die "Prepares a file to be visualized in color in KEGG\nUsage : ./prepare_kegg_file.pl <genenames> <scoress>\n<genename> = name of a file with a list of gene (one in each line)\n<scores> = name of a file with the corresponding scores";
}

# rainbow
# my @colormap= ("#7fffff", "#00ffff", "#007f7f", "#0000ff", "#7f00ff", "#ff00ff", "#ff007f", "#ff0000", "#ff7f00", "#ffff00", "#7fff00", "#00ff00", "#007f00", "#a08000", "#511900" , "#00000");

# yellow
# my @colormap= ("#000000","#202000","#404000","#606000","#808000","#a0a000","#c0c000","#e0e000","#ffff00","#ffff20","#ffff40","#ffff60","#ffff80","#ffffa0","#ffffc0","#ffffe0");

# red to green 
my @colormap= ("#ff0000","#c00000","#800000","#000000","#008000","#00c000","#00ff00");

my $colornb = $#colormap+1;

# Read the gene names
open (INPUT , $ARGV[0]) || die "Cannot open ".$ARGV[0]." : $!";
my @genename = <INPUT>;
close (INPUT);
my $genenb = $#genename+1;


# Read the scores
open (INPUT , $ARGV[1]) || die "Cannot open ".$ARGV[0]." : $!";
my $i=0;
my $line; my %genescore=();

while ($line = <INPUT>) {
	if ($i > $genenb-1) { 
		die "Error :  too many lines in the file ".$ARGV[1]." (for only $genenb entries in the file ".$ARGV[1]."\n";
	}
  chomp $line;
  chomp $genename[$i];
  $genescore{$genename[$i]} = $line;
  $i++
}
close (INPUT);


# sort them by decreasing score and assign colors
my $step = int($genenb) / int($colornb);
$i=0;
foreach $line (sort {$genescore{$a} <=> $genescore{$b}} (keys %genescore)) {
	print $line."\t".$colormap[int($i/$step)]."\n";
	$i++;
}

